package top.ninwoo.utils.util.impl;

import org.springframework.beans.factory.annotation.Autowired;
import top.ninwoo.utils.util.DockerUtils;
import top.ninwoo.utils.util.TcUtils;

/**
 * @Author joliu
 * @Description
 * @Date　Create in 下午5:20 2019/10/30
 */
public class TcUtilsImpl implements TcUtils {

    @Autowired
    DockerUtils dockerUtils;

    /**
     * 这是个
     * @param containerId
     * @param maxRate
     * @param minRate
     * @return
     */
    public boolean addQos(String containerId, String maxRate, String minRate) {
        String resul = "";
        // 开启限速
        dockerUtils.execInDocker(containerId, "tc qdisc add dev eth1 root handle 1: htb default 20");
        // 下行总速率5Mbit
        dockerUtils.execInDocker(containerId, "tc class add dev eth1 parent 1:0 classid 1:1 htb rate " + maxRate);
        // 1 号通道的下行速度，最小3Mbit 最大5 Mbit （还可以添加优先级）
        dockerUtils.execInDocker(containerId, "tc class add dev eth1 parent 1:1 classid 1:20 htb rate " + minRate + " ceil " + maxRate);
        // 使用了一个公平侧率
        dockerUtils.execInDocker(containerId, "tc qdisc add dev eth1 parent 1:20 handle 20: sfq perturb 10");
        // 设置了一个过滤器--TODO: 这个好像没有生效
        dockerUtils.execInDocker(containerId, "tc filter add dev eth1 parent 1:20 protocol ip u32 match ip sport 5002 0xffff classid 1:20");

        return true;
    }

    /**
     * 解除限速
     * @param containerId
     * @return
     */
    public boolean delQos(String containerId) {
        String res = dockerUtils.execInDocker(containerId, "tc qdisc del dev eth1 root");
        if(!"".equals(res)) {
            return false;
        }
        return true;
    }
}
